	;include	"exec/exec.i"
	;include	"exec/exec_lib.i"
	;include	"graphics/graphics_lib.i"

	include	"hardware/demo.i"

WRASTER=$130
MA	; music arranger

	include	mystartup.i

	;move.l	4,a6
	;lea	gfxname(pc),a1
	;moveq	#0,d0
	;jsr	_LVOOpenLibrary(a6)
	;tst.l	d0
	;beq	nogfx
	;
	;move.l	d0,gfxlib
	;
	;jsr	_LVOForbid(a6)	
	;jsr	_LVODisable(a6)

	;move.l	gfxlib,a6
	;jsr	_LVOWaitTOF(a6)
	
	;move.l	syscop1(a6),cop1store
	;move.l	syscop2(a6),cop2store

	;lea	Custom,a6
	;move.w	intenar(a6),intenastore
	;move.w	dmaconr(a6),dmaconstore

	;move.w	#$7fff,d0
	;move.w	d0,dmacon(a6)
	;move.w	d0,intena(a6)


MAIN	bsr 	InitMusic
	lea	Custom,a6
	
	move.w	#$7fff,intena(a6)
	move.w	#$7fff,intreq(a6)
	move.w	#$8380,dmacon(a6)


	;write bitplane 4 & 5 pointers

	move.l	#screen,d0
	lea	pl4,a0
	move.w	d0,6(a0)
	swap	d0
	move.w	d0,2(a0)

	move.l	#screen2,d0
	lea	pl5,a0
	move.w	d0,6(a0)
	swap	d0
	move.w	d0,2(a0)


	;generate 8 colours for the static

	lea	staticcols,a0
	lea	staticcop,a1
	move.w	#8-1,d0
makestaticcols
	move.b	(a0)+,d1
	ext.w	d1
	move.w	d1,d2
	lsl.w	#4,d2
	or.w	d2,d1
	lsl.w	#4,d2
	or.w	d2,d1
	move.w	d1,2(a1)
	add.l	#4,a1
	dbf	d0,makestaticcols

	clr.w	alpha
	st.b	fadeinneeded
	sf.b	fadeoutneeded
	sf.b	textneeded

	lea	screen,a0
	bsr	resetscreen
	
	lea	screen2,a0
	bsr	resetscreen

	lea	text,a0
	lea	screen,a1
	bsr	textwriter	
	move.l	a0,textptr2
	
	move.l	#randoms2,randptr
	
	lea	newvbl(pc),a0
	lea	VBLpt(pc),a1
	move.l	a0,(a1)

	move.w	#$c020,intena(a6)

	move.l	#coplist,cop1lch(a6)
	move.l	#0,cop2lch(a6)
	clr.w	copjmp1(a6)


dowait	BSR	waitraster

	tst.b	textneeded
	beq	notextyet

	sf.b	fadeoutneeded
	sf.b	fadeoutdone

	move.l	textptr2,a0	
	
	tst.b	(a0)
	beq	notextyet

	;write next block of text
	lea	screen,a1
	bsr	textwriter
	move.l	a0,textptr2
	sf.b	textneeded
	st.b	fadeinneeded
	sf.b	fadeindone
	
	move.w	alpha,d0
	
notextyet	tst.b	fadeinneeded
	beq	stillfading1
	tst.b	fadeindone
	beq	stillfading1

	;copy plane 4 to plane 5
	lea	screen,a0
	lea	screen2,a1
	move.w	#288*46/2-1,d0
copyplane	move.w	(a0)+,(a1)+
	dbf	d0,copyplane

	sf.b	fadeinneeded
	sf.b	fadeindone
	
	tst.b	fadeoutneeded
	bne	abouttofadeout

	st.b	textneeded
	clr.w	alpha
	bra	stillfading1

abouttofadeout
	lea	screen2,a0
	bsr	resetscreen


stillfading1
	tst.b	fadeoutneeded
	beq	stillfading2
	
	tst.b	fadeoutdone
	beq	stillfading2

	lea	screen,a0
	bsr	resetscreen
	
	sf.b	fadeoutdone
	sf.b	fadeoutneeded
	st.b	textneeded

stillfading2

	bsr	doalpha

	movem.l	d0,-(sp)
.loop	move.l	$dff004,d0
	and.l	#$1ff00,d0
	cmp.l	#WRASTER<<8,d0
	beq.b	.loop
	movem.l	(sp)+,d0
	
nomoretext	btst	#6,CIAA
	bne	dowait

exit	bsr	StopMusic

	;lea	Custom,a6

	;move.w	#$7fff,intena(a6)
	;move.w	intenastore,d0
	;or.w	#$8000,d0
	;move.w	d0,intena(a6)
	
	;move.w	#$7fff,dmacon(a6)
	;move.w	dmaconstore,d0
	;or.w	#$8000,d0
	;move.w	d0,dmacon(a6)
	
	;move.l	cop1store,cop1lc(a6)
	;move.l	cop2store,cop2lc(a6)
	
	;move.l	gfxlib,a6
	;move.l	oldview,a1
	;jsr	_LVOLoadView(a6)

	;move.l	gfxlib,a1
	;jsr	_LVOCloseLibrary(a6)
	
	;move.l	4,a6
	;jsr	_LVOEnable(a6)	
	;jsr	_LVOPermit(a6)
	
nogfx	clr.l	d0
	rts


;get a random number from the random numbers table
;and reset the pointer if necessary
getrandom	move.w (a2)+,d1
	cmp.l	#rand2end,a2
	bne noreset
	
	lea	randoms2,a2
noreset	rts



;vertical blank routine
;generat the bitplane pointers for the copper list
;and play the tune
newvbl	move.l	randptr,a2
	lea	copscr,a0
	lea	randoms,a1

	move.w	#144-1,d7	

doscreen3	lea	4(a0),a0

	move.w	#3-1,d0

doscreen2	bsr	getrandom
	
	lea 0(a1,d1),a3
	move.l	a3,d1

	move.w	d1,6(a0)
	swap	d1
	move.w	d1,2(a0)
	
	;swap	d1
	lea	8(a0),a0
	dbf	d0,doscreen2
	lea	4(a0),a0
	bsr	getrandom
	bsr	getrandom

	dbf	d7,doscreen3
	move.l	a2,randptr
	
	bsr	PlayMusic
	
	rts

;basic text writer routine
;
;text address in a0
;
;special codes are
;1,x,y - move cursor (bit 7 of x indicates shift to the right by half a character)
;2 - trigger a fade out after the text is written

textwriter	move.b	(a0)+,d0
	tst.b	d0
	beq	textdone
	
	cmp.b	#1,d0
	bne	notcursorpos
	
	move.b	(a0)+,d0
	btst	#7,d0
	sne	halfline
	
	and.w	#$7f,d0
	
	ext.w	d0
	move.w	d0,cursorxpos
	
	move.b	(a0)+,d0
	ext.w	d0
	move.w	d0,cursorypos
	bra	textwriter

notcursorpos
	cmp.b	#2,d0
	bne	notcls
	
	st.b	fadeoutneeded
	move.w	#200,fadedelay
	bra	textwriter
	
notcls	cmp.b	#32,d0
	beq	space
	
notspce	sub.b	#32,d0
	lea	font,a2
	ext.w	d0
	lsl.w	#3,d0
	lea	(a2,d0),a2
	
	move.w	cursorypos,d0
	mulu	#46*8,d0
	add.w	cursorxpos,d0
	lea 	(a1,d0),a3

	tst.b	halfline
	beq	noshift
	

	move.w	#8-1,d7
	clr.w	d2	
nextrow	move.b	(a2)+,d0
	move.b	d0,d1
	lsr.b	#4,d0
	and.b	#$f,d0
	lsl.b	#4,d1
	or.b	d0,(a3,d2)
	or.b	d1,1(a3,d2)
	add.w	#46,d2
	dbf	d7,nextrow
	
		
		
space	add.w	#1,cursorxpos
	bra	textwriter
		
noshift	move.b	(a2)+,(a3)
	move.b	(a2)+,46(a3)
	move.b	(a2)+,92(a3)
	move.b	(a2)+,138(a3)
	move.b	(a2)+,184(a3)
	move.b	(a2)+,230(a3)
	move.b	(a2)+,276(a3)
	move.b	(a2)+,322(a3)
	
	add.w	#1,cursorxpos
	
	bra	textwriter
textdone	rts

doalpha	lea	fadecols,a0
	
	move.w	#8-1,d1
	clr.w	d4



;calculate the alpha blending palette
;and update the alpha value according to whether
;we are fading in or out then update the
;fade complete flags

	lea	staticcols,a1

calcalpha	move.w	alpha,d0

	move.w	#$f,d2
	mulu	d0,d2
	move.w	d2,d5

	move.w	#256,d0
	sub.w	alpha,d0
	move.b	(a1)+,d2
	ext.w	d2
	mulu	d0,d2
	
	add.w	d5,d2
	
	and.w	#$f00,d2
	
	move.w	d2,d3
	lsr.w	#4,d3
	move.w	d3,d4
	lsr.w	#4,d4

	;lsr.w	#2,d2
	;and.w	#$f00,d2
	
	or.w	d3,d2
	
	
	;lsr.w	#2,d4
	or.w	d4,d2

	move.w	d2,2(a0)
	add.l	#4,a0	
	dbf	d1,calcalpha
	
	move.w	alpha,d0
	
	tst.b	fadeinneeded
	beq	nofadein
	
	tst.b	fadeindone
	bne	nofadein
	
	cmp.w	#256,d0
	beq	fadeincomplete
	
	add.w	#4,d0
savealpha	move.w	d0,alpha
	rts
	
fadeincomplete
	st.b	fadeindone
	rts
	
nofadein	tst.b	fadeoutneeded
	beq	nofadeout
	
	tst.b	fadeoutdone
	bne	nofadeout

	tst.w	fadedelay
	beq	delaydone
	
	sub.w	#1,fadedelay
	rts
	
delaydone	tst.w	d0
	beq	fadeoutcomplete
	
	
	sub.w	#4,d0
	bra	savealpha

fadeoutcomplete
	st.b	fadeoutdone
nofadeout	rts


;copy the screen data from screen3
;in order to clear the screen

resetscreen	move.w	#288-1,d0
	lea	screen3,a1

cls2	move.w	#23-1,d1
cls1	move.w	(a1)+,(a0)+
	dbf	d1,cls1
	lea	2(a1),a1
	dbf	d0,cls2
	rts
	
text	dc.b	1,18,5,"- F L A S H T R O -",0
	dc.b	1,18,8,"B R I N G S   Y O U",0
	DC.B	1,16+128,13,"A NEW AMIGA PRODUCTION",0
	
	dc.b	1,24,18,"IN 2014",2,0

	dc.b	1,16+128,6,"RING OUR ULTRA HOT BBS"
	dc.b	1,13,11,"BBS1 (UKHQ)  -   44-CLOSED-DOWN"
	dc.b	1,13,13,"BBS2 (WHQ)   -    1-NOT-ANYMORE"
	dc.b	1,13,15,"BBS3         -   43-LONG-GONE"
	
	dc.b	1,15,20,"OR VISIT WWW.FLASHTRO.COM",2,0


	dc.b	1,17+128,5,"GREETINGS FLY OUT TO",0
	
	dc.b	1,15,8,"QUARTEX",0
	dc.b	1,23,8,"FAIRLIGHT",0
	dc.b	1,33,8,"TRSI",0
	dc.b	1,38,8,"LSD",0
	dc.b	1,15,10,"PRODIGY",0
	dc.b	1,23,10,"CRYSTAL",0
	dc.b	1,31,10,"PARANOIMIA",0
	dc.b	1,16+128,12,"PRESTIGE",0
	dc.b	1,25+128,12,"CLASSIC",0
	dc.b	1,33+128,12,"ZENITH",0
	dc.b	1,14+128,14,"ANGELS",0
	dc.b	1,21+128,14,"VISION FACTORY",0
	dc.b	1,36+128,14,"RAZOR",0
	dc.b	1,16,16,"SKID ROW",0
	dc.b	1,25,16,"PARADOX",0
	dc.b	1,33,16,"ANTHROX",0
	dc.b	1,17+128,18,"DEFJAM",0
	dc.b	1,24+128,18,"ORACLE",0
	dc.b	1,31+128,18,"HORIZON",0

	dc.b	1,20,22,"AND ALL THE REST",2,0
	
	dc.b	1,19,5,"- C R E D I T S -"
	
	dc.b	1,14+128,8," CODE AND DESIGN PHANTASM"
	
	dc.b	1,19,10,"FONT SOMEONE ELSE"
	
	dc.b	1,21+128,12,"MUSIC BY MC"


	dc.b	1,17+128,17,"HIT THE LEFT BUTTON",0
	
	

	dc.b	0

	
gfxname	dc.b	"graphics.library",0

	ifd	HIP
	include	"Hippel.s"
	endc
	ifd	FC
	include	"FutureComposer.s"
	endc
	ifd	DMU
	include	"player(pc).s"
	endc

	section	static,data

staticcols	dc.b	0,1,2,3,4,5,6,7


font	incbin	"cobra.fnt"

;random offsets into the random bitplane data
randoms2	dc.w	1308,324,586,746,1050,375,971,589,543,1439,1382,142,379,468,827,165,3,520,1016,34,1236
	dc.w	787,2205,1515,503,10,1295,1094,300,66,350,125,1720,2403,23,257,2126,540,1181,752,513
	dc.w	830,365,334,740,158,1518,91,40,980,22,595,122,108,318,290,682,12,245,1008,395
	dc.w	33,192,981,631,1104,105,1028,238,31,1491,320,234,407,2039,173,131,49,338,827,562
	dc.w	774,578,51,165,11,3,605,114,832,58,24,519,1744,949,1573,2070,303,890,433,258
	dc.w	12,1629,235,92,1044,586,1776,1368,302,468,1066,1132,7,69,442,1998,82,33,797,146
	dc.w	1047,493,463,448,986,431,650,22,565,1377,114,1000,2123,1757,127,689,536,131,223,1594
	dc.w	181,688,1762,175,1781,507,1378,411,887,861,99,13,771,1188,282,459,1301,55,62,374
	dc.w	25,2230,961,58,52,97,80,10,637,2333,136,17,491,1618,1352,136,1453,266,1094,924
	dc.w	105,510,584,1513,546,18,104,333,1736,15,1275,141,25,388,155,844,534,359,240,206
	dc.w	131,1441,1135,8,529,473,1144,1161,462,223,1272,6,1075,257,665,176,1085,1149,1090,156
	dc.w	279,926,41,614,1676,1339,423,1619,179,397,1589,1037,71,68,599,965,1355,54,85,1357
	dc.w	767,461,43,963,284,77,1105,78,1094,242,449,597,908,44,1580,362,386,705,0,1117
	dc.w	1397,1635,2332,967,923,1961,521,369,1286,50,587,1162,2188,1046,325,51,561,514,879,245
	dc.w	253,163,26,791,0,705,416,38,423,176,457,204,144,333,1925,634,954,1478,1144,153
	dc.w	987,11,825,753,676,264,209,1145,519,300,770,941,1313,926,56,7,65,234,638,1133
	dc.w	780,67,102,1043,885,1537,427,717,559,949,8,176,1123,21,1,983,1295,2103,277,1665
	dc.w	1448,618,347,3,408,1095,1078,1597,275,247,1665,177,0,505,1411,1042,209,107,1853,226
	dc.w	1374,846,896,1284,286,271,172,45,1081,954,800,403,1582,149,1014,38,2024,24,1261,82
	dc.w	644,73,395,137,1573,621,1305,1392,574,870,385,301,318,61,512,461,92,168,1560,1274
	dc.w	70,1804,213,1226,916,400,2052,71,555,651,46,189,931,396,198,816,998,1330,315,133
	dc.w	312,38,25,386,1141,61,1814,1020,513,765,668,401,110,1486,405,281,136,879,921,1340
	dc.w	494,481,325,698,1782,717,435,526,3,195,244,750,2312,1225,858,1190,1623,60,197,388
	dc.w	388,34,156,185,203,22,388,94,223,588,38,127,352,379,524,2050,2,481,231,226
	dc.w	3,2027,1064,137,360,1236,6,370,1326,3,410,46,73,726,435,25,638,1493,32,112
	dc.w	144,1619,80,214,120,167,491,1114,860,105,594,1190,772,201,251,401,50,464,813,140
	dc.w	193,895,315,1099,293,1599,1432,2193,708,1776,175,437,329,493,454,1311,449,123,420,623
	dc.w	827,1946,2119,359,148,255,537,733,1441,87,691,696,207,241,130,236,727,334,474,710
	dc.w	400,869,617,168,106,1249,390,276,63,45,302,1389,36,622,1905,414,831,545,60,1574
	dc.w	1163,41,653,380,307,238,231,563,187,853,3,1126,953,696,62,365,758,637,936,1342
	dc.w	54,440,175,938,106,300,1412,1271,136,830,1243,879,2410,172,221,169,1046,48,0,466
	dc.w	36,87,283,19,1592,478,1536,174,1207,447,1471,23,156,694,473,676,1055,1237,17,190
	dc.w	213,10,493,516,1028,840,449,131,84,7,1717,820,290,13,235,6,1336,466,1072,154
	dc.w	652,1324,15,3,62,716,150,53,36,1455,13,483,317,16,335,267,369,230,101,21
	dc.w	501,1960,386,292,5,329,34,879,1127,422,324,752,213,697,175,9,1672,766,459,1841
	dc.w	232,779,9,2117,1614,180,1887,215,625,1127,233,187,893,0,631,0,57,328,61,37
	dc.w	930,1884,173,312,1507,192,333,391,48,52,555,337,36,1349,47,644,159,1238,600,339
	dc.w	1817,674,104,49,256,706,493,139,1940,505,1139,480,453,1653,1039,979,15,1209,67,1011
	dc.w	2148,1711,1432,887,57,741,932,777,71,355,339,1934,707,25,307,407,1788,190,1,240
	dc.w	713,442,461,116,131,115,189,783,73,2126,594,678,150,345,2181,897,519,677,13,267
	dc.w	292,103,459,35,183,274,50,1630,787,742,679,597,1796,809,5,1018,848,1724,356,612
	dc.w	11,116,103,398,831,1357,537,936,33,489,189,39,589,1342,19,130,2046,192,298,591
	dc.w	653,590,316,860,1057,1203,281,716,733,313,549,218,107,1002,978,982,278,727,97,75
	dc.w	106,348,84,944,1052,93,340,973,1,5,835,372,43,1490,26,560,183,111,228,462
	dc.w	115,214,205,335,68,1579,1248,859,37,1326,1303,144,1203,396,141,0,1006,1017,91,201
	dc.w	167,937,453,18,499,52,228,1505,1170,10,678,1332,1936,150,832,290,216,382,79,1362
	dc.w	0,1805,538,869,1842,1522,1179,108,96,361,77,1404,170,1372,586,338,749,415,658,1430
	dc.w	610,242,21,555,7,145,279,514,1552,1681,1445,476,415,281,459,330,501,360,887,1246
	dc.w	2,431,477,1453,601,779,1076,743,697,1700,1013,974,21,104,234,258,1957,323,645,383
	dc.w	496,455,39,829,1461,379,359,669,33,1739,645,959,756,2034,402,1343,631,1399,226,2180
	dc.w	533,108,535,1305,882,53,1685,1775,592,91,1238,885,69,27,430,303,682,436,1440,1371
	dc.w	1656,1420,408,34,224,45,84,434,2355,108,2069,697,850,405,733,795,457,16,583,1767
	dc.w	1238,76,619,776,2353,332,227,719,702,170,1152,533,12,346,720,109,841,1578,223,41
	dc.w	132,367,214,1699,2129,640,114,2419,33,412,321,42,106,76,1104,259,643,547,135,870
	dc.w	552,896,72,663,29,608,748,1111,552,198,52,920,319,65,1692,1457,412,760,413,410
	dc.w	285,78,116,54,740,147,111,1484,250,2128,276,167,627,131,24,1113,5,756,60,123
	dc.w	1136,336,165,133,733,1179,150,1161,482,45,1494,925,711,815,573,536,21,1683,580,306
	dc.w	133,457,741,716,2397,212,109,24,1688,132,828,719,354,352,282,2313,685,346,141,101
	dc.w	0,514,47,20,848,1327,784,161,34,591,29,468,117,1700,583,344,994,545,207,109
	dc.w	153,1402,421,609,479,964,80,55,215,149,482,1351,1552,772,53,189,579,290,454,616
	dc.w	1006,122,1112,171,1536,155,631,67,197,937,815,470,14,431,230,199,290,102,414,981
	dc.w	247,707,51,936,299,10,571,18,1246,58,997,216,117,145,9,680,62,487,280,523
	dc.w	1281,693,2,989,183,504,4,62,48,251,451,495,299,112,1068,856,512,166,609,24
	dc.w	25,695,820,54,875,405,1674,79,664,6,1126,110,385,1360,268,340,577,996,1033,1121
	dc.w	936,777,397,219,12,869,782,1671,99,580,1196,605,15,191,2020,1350,1090,649,307,142
	dc.w	997,1852,152,299,1157,1195,1729,283,294,477,1224,436,17,93,124,337,255,406,213,169
	dc.w	21,1656,603,472,170,569,328,1036,160,43,227,445,428,1008,50,742,2083,735,59,71
	dc.w	417,588,1794,81,706,719,1154,390,763,305,334,718,168,1870,1027,175,638,141,1060,70
	dc.w	90,874,1395,635,56,773,754,295,406,9,1797,524,446,1913,841,88,305,967,19,498
	dc.w	1622,1383,96,1070,933,237,295,1541,5,1132,118,93,1707,1919,592,37,1850,203,1360,1318
	dc.w	123,976,330,596,800,734,2306,5,2061,1822,2252,230,968,1334,1811,218,13,2248,58,229
	dc.w	340,502,1288,433,9,691,1326,189,1811,1176,259,1615,84,391,1894,1290,240,78,43,638
	dc.w	152,244,272,834,95,9,110,128,399,378,470,9,1269,1358,1169,315,4,762,182,414
	dc.w	128,42,26,340,225,257,1484,232,1321,584,348,22,1091,258,383,9,278,542,153,254
	dc.w	80,732,477,1164,799,1387,923,445,55,1525,1074,1304,502,322,360,1039,22,189,822,292
	dc.w	187,46,20,272,543,155,268,546,315,16,1040,36,0,1587,1658,612,509,4,1707,239
	dc.w	995,604,376,298,307,327,1257,34,784,426,144,149,237,371,441,278,1335,109,55,281
	dc.w	59,480,158,251,896,391,1099,771,1838,100,2350,438,890,1804,53,271,93,740,801,94
	dc.w	626,2191,533,140,1200,266,286,829,91,270,284,568,127,369,1693,567,257,18,450,524
	dc.w	206,1037,37,1732,1523,271,878,275,368,1482,179,56,523,1256,223,496,199,130,143,581
	dc.w	368,1159,234,25,586,62,565,237,124,1171,870,588,576,1594,284,2232,1400,1649,351,1190
	dc.w	789,174,1452,1087,36,1328,691,1438,1042,44,731,336,205,44,161,719,895,252,18,109
	dc.w	1815,240,1138,135,257,2007,361,536,917,564,695,1,573,260,399,984,439,423,793,784
	dc.w	90,0,62,24,75,318,145,423,45,114,1879,377,97,193,443,1246,93,552,254,49
	dc.w	1143,169,88,1059,496,25,192,758,526,1477,189,1108,1220,189,553,231,735,62,63,1332
	dc.w	22,100,971,565,529,470,698,71,284,51,438,457,134,247,253,101,9,270,2170,430
	dc.w	363,272,395,398,385,433,83,604,1531,95,356,279,325,754,345,301,575,1994,280,373
	dc.w	824,281,177,1476,1630,237,11,1337,205,625,55,188,785,629,88,101,2028,87,1228,142
	dc.w	157,762,1074,2,121,1041,546,965,1734,994,416,308,807,134,1024,125,46,265,909,342
	dc.w	217,1579,1073,934,384,674,926,535,373,1226,765,434,831,285,824,284,91,239,38,432
	dc.w	399,1208,706,1968,230,1703,72,573,531,505,38,1685,483,9,911,165,364,620,528,1637
	dc.w	95,1882,1077,557,712,796,795,987,429,21,942,276,6,254,1344,27,46,100,65,1079
	dc.w	1117,1157,380,224,227,660,832,793,1211,122,22,550,66,94,190,1298,319,1441,351,6
	dc.w	2161,1163,1415,509,1213,1009,603,653,964,304,1764,121,695,2133,198,1779,1596,116,364,1463
	dc.w	441,605,1523,49,1178,468,208,419,871,353,1663,975,1746,302,359,1092,707,933,883,1939
	dc.w	1479,195,780,1321,811,1326,1329,328,482,63,19,197,2201,114,189,914,803,596,1894,1049
	dc.w	301,437,1155,16,1108,829,694,720,74,378,24,1094,2031,1284,445,37,895,182,409,149
	dc.w	1614,504,225,850,11,245,574,37,1056,821,193,99,1055,303,224,1045,419,405,667,1881
	dc.w	65,593,182,985,196,963,149,18,19,1059,175,96,88,1472,284,1390,3,326,899,17
	dc.w	434,1161,262,14,1110,319,16,824,1171,1090,50,226,445,724,24,1768,578,578,122,1606
	dc.w	922,685,230,186,1966,47,1497,78,1274,68,1021,705,928,234,1515,413,1197,201,725,1480
	dc.w	1094,1,863,429,1049,28,355,602,584,225,167,63,203,1033,490,817,137,163,114,287
	dc.w	452,142,756,753,184,47,1100
rand2end

	section	mainbss,bss	
intenastore	ds.w	1
dmaconstore	ds.w	1
cop1store	ds.l	1
cop2store	ds.l	1
gfxlib	ds.l	1
oldview	ds.l	1
cursorxpos	ds.w	1
cursorypos	ds.w	1
alpha	ds.w	1
textptr2	ds.l	1
randptr	ds.l	1
fadedelay	ds.w	1
count	ds.w	1
halfline	ds.b	1
fadeindone	ds.b	1
fadeoutdone	ds.b	1

fadeinneeded
	ds.b	1
fadeoutneeded
	ds.b	1
textneeded	ds.b	1

	section	chipbss,bss_c
	


	section	chipdata,data_c

	ifd	MA
Module:	incbin	"MA.OneMan&Droid"
	endc
screen	ds.b	288*46
screen2	ds.b	288*46
screen3	incbin	"flashtro3.raw"
	ds.b	27*46;
scr3end


;random bitplane data for static
randoms	dc.b 131,18,8,236,200,81,198,47,118,236,225,22,104,228,102,56,76,72,219,216,197,157,219,52,73,141,96,44,90,210,239,249,212,17,45,254,69,35,133,241,84,99,197,143,208,178,29,173,52,162
	dc.b 30,65,44,189,73,220,83,43,219,176,209,248,111,105,163,126,253,27,51,14,121,151,11,66,45,169,119,169,114,183,157,108,249,190,125,69,175,37,153,58,38,189,244,229,204,117,133,33,18,94
	dc.b 57,6,237,198,223,83,193,157,19,183,152,16,204,25,208,63,66,63,222,129,65,25,218,118,172,148,52,243,84,30,240,181,24,143,255,217,122,176,171,115,151,185,232,121,186,108,180,249,170,92
	dc.b 20,71,143,154,188,200,68,72,167,120,44,88,111,139,212,142,63,21,139,215,142,25,2,225,89,56,63,8,10,96,200,146,44,121,223,145,119,97,159,50,210,127,151,179,54,43,137,204,127,210
	dc.b 58,224,74,227,10,186,224,9,66,85,34,206,232,52,22,154,134,129,234,173,78,200,0,151,242,137,215,9,13,94,69,68,83,42,34,17,236,171,221,36,129,137,11,156,252,231,218,215,19,245
	dc.b 79,194,190,248,44,182,151,176,223,105,171,222,43,47,97,182,144,30,141,136,189,128,54,151,203,7,234,13,222,179,80,60,137,247,209,104,117,224,252,254,74,164,190,159,94,229,246,59,192,51
	dc.b 104,25,120,160,119,213,142,144,226,169,141,204,6,62,161,236,238,98,43,7,255,193,118,113,28,83,112,125,159,217,147,107,115,205,133,224,181,233,253,13,246,171,86,114,119,62,234,88,38,139
	dc.b 92,136,79,78,96,173,134,25,44,118,127,34,115,51,100,211,66,127,167,34,154,68,11,16,221,250,124,4,182,246,1,78,174,143,125,188,214,240,228,194,56,224,200,141,133,103,74,31,112,70
	dc.b 221,111,57,86,16,79,249,205,175,214,22,118,147,160,53,79,230,40,214,53,79,48,252,242,79,90,207,81,156,79,110,242,244,162,199,228,170,184,29,53,221,106,140,111,8,135,174,74,115,76
	dc.b 59,146,127,230,132,114,8,139,49,157,161,150,33,2,211,60,232,120,179,81,216,36,38,145,65,130,105,74,189,133,166,223,100,127,33,116,206,93,213,8,186,156,131,172,254,203,62,61,221,2
	dc.b 160,242,172,131,185,108,91,121,108,252,175,192,54,46,125,7,44,96,252,4,102,24,202,244,164,99,168,26,17,9,230,49,94,98,36,186,40,19,149,32,47,12,42,136,36,215,83,135,203,57
	dc.b 218,150,202,135,117,92,230,89,198,0,178,248,186,188,5,230,238,30,221,44,206,47,16,14,34,206,236,220,222,88,151,21,129,250,242,149,13,57,142,165,182,137,176,189,180,121,160,63,88,58
	dc.b 243,80,127,131,248,142,58,78,82,69,246,161,135,44,234,237,1,216,40,113,208,196,114,196,216,161,243,103,23,154,212,215,170,160,179,245,178,91,121,127,210,13,164,98,225,229,204,218,34,113
	dc.b 55,96,43,129,178,60,223,21,144,13,214,17,107,29,187,217,19,120,183,158,55,65,230,234,114,162,4,99,192,28,152,162,146,126,113,4,112,186,106,169,64,183,134,98,226,64,105,86,98,227
	dc.b 213,112,25,164,197,32,37,191,159,2,114,184,212,161,200,110,183,66,203,132,32,205,205,194,222,64,181,160,152,136,245,29,34,109,194,145,128,173,29,182,89,243,153,252,247,88,209,249,94,45
	dc.b 172,162,103,222,104,204,54,163,222,81,114,150,118,116,26,150,57,13,154,103,50,56,139,168,228,111,145,236,159,152,134,135,19,247,192,29,230,222,147,222,10,20,238,169,107,133,75,23,210,57
	dc.b 48,66,34,41,61,77,88,170,209,27,232,115,250,174,154,69,15,31,47,182,92,223,223,10,8,123,19,16,87,106,198,67,142,71,41,228,246,48,250,179,176,43,22,81,212,233,68,178,135,8
	dc.b 231,216,30,46,124,92,251,183,202,149,151,158,129,222,239,150,211,227,212,121,241,230,109,133,151,156,159,94,247,29,122,128,93,167,188,69,49,125,254,243,221,16,44,38,94,34,111,66,95,132
	dc.b 197,232,82,169,28,4,132,220,117,134,112,223,122,206,149,87,56,77,80,5,16,29,220,216,227,246,172,102,105,127,144,49,79,1,188,241,36,147,80,254,16,143,27,30,182,44,151,60,45,104
	dc.b 231,167,15,17,78,7,14,88,167,240,25,177,25,198,124,227,190,171,193,132,15,9,238,52,66,48,33,137,192,131,209,118,114,131,65,100,24,29,160,217,121,69,137,28,209,223,111,176,181,237
	dc.b 104,104,177,120,29,157,7,232,67,10,171,225,218,69,188,56,98,198,179,180,218,101,208,217,58,67,107,121,160,175,54,248,99,12,141,2,91,69,154,3,169,187,83,191,57,87,13,216,111,210
	dc.b 99,141,247,74,136,205,145,132,200,51,179,26,153,121,35,211,217,7,157,201,72,12,144,141,2,142,171,170,108,175,66,76,98,27,61,110,109,135,108,158,87,210,95,16,251,183,194,85,3,161
	dc.b 71,138,93,203,122,126,190,187,164,58,1,240,170,147,70,97,116,238,38,249,206,92,157,128,250,46,55,125,176,246,165,201,228,225,138,106,250,248,232,131,174,188,135,194,161,5,59,129,54,207
	dc.b 127,190,89,19,225,26,230,127,87,62,194,252,255,55,145,201,107,201,139,39,63,184,208,213,75,98,88,85,229,246,132,146,179,9,228,206,32,82,142,206,216,227,220,248,20,230,209,71,10,112
	dc.b 135,169,87,206,235,170,80,210,0,199,208,104,205,191,43,26,103,230,0,18,12,66,230,28,169,91,78,54,240,202,17,186,22,165,161,217,21,204,152,109,69,250,155,41,145,143,129,248,87,205
	dc.b 51,167,147,205,203,20,231,176,48,88,7,246,195,50,196,102,182,193,206,43,106,5,37,196,108,178,245,173,158,146,117,205,16,181,20,204,208,115,207,65,104,139,55,84,11,17,17,126,202,9
	dc.b 108,151,143,139,123,142,254,252,73,169,117,34,239,122,230,165,210,52,239,215,126,75,212,143,200,75,122,229,116,124,171,170,152,240,188,0,143,135,163,222,175,65,148,48,0,93,164,102,25,53
	dc.b 93,100,142,212,124,218,6,161,63,8,178,24,205,132,48,153,30,67,246,201,109,82,220,3,228,190,166,63,93,208,157,179,154,2,151,90,137,233,207,39,242,35,202,77,173,219,211,212,153,50
	dc.b 59,49,187,61,245,107,55,166,167,39,152,108,140,199,193,203,24,84,137,94,148,73,157,95,138,249,56,95,125,240,91,78,14,250,236,89,57,51,121,241,99,206,78,55,209,139,182,75,238,196
	dc.b 206,165,153,199,55,254,177,148,23,94,196,53,17,74,53,108,211,244,144,54,2,118,221,53,210,151,61,221,36,220,173,130,151,17,55,150,73,66,213,50,61,0,237,160,114,230,4,168,253,53
	dc.b 149,82,142,37,60,172,98,232,243,195,128,239,163,50,95,71,50,212,110,129,216,23,198,152,39,25,0,61,228,165,46,213,82,138,157,126,240,193,166,254,2,17,28,16,55,132,18,95,149,134
	dc.b 159,245,60,154,218,50,141,241,219,235,138,182,250,41,215,127,143,216,169,103,33,187,201,84,156,16,36,160,243,174,180,242,169,63,83,229,202,116,56,215,72,197,198,113,51,100,186,137,83,101
	dc.b 118,146,234,153,123,115,125,87,114,62,42,135,51,184,35,240,65,205,175,28,129,35,185,215,110,119,121,3,19,208,229,84,107,10,155,194,207,12,124,109,184,148,20,7,166,155,240,67,165,106
	dc.b 14,181,85,152,203,90,255,162,1,219,235,45,14,192,210,139,69,12,177,181,241,157,155,67,30,234,87,218,214,183,6,145,71,29,169,204,148,241,3,8,58,239,54,240,204,221,24,71,18,140
	dc.b 27,144,248,198,151,105,7,156,154,116,33,139,17,25,71,52,206,185,244,20,105,37,53,153,65,204,126,103,96,29,158,130,94,174,40,139,111,173,59,212,145,116,189,146,23,239,162,224,165,219
	dc.b 178,14,58,31,199,128,178,59,155,79,199,112,93,55,21,84,118,254,212,69,134,144,126,188,12,190,199,20,160,151,185,114,25,151,109,231,187,50,196,171,97,26,149,92,227,223,232,18,150,143
	dc.b 74,201,61,232,240,152,57,188,221,222,0,214,219,50,113,39,55,50,56,180,200,99,9,182,108,177,62,34,44,118,112,211,47,162,232,127,205,161,223,193,65,39,242,105,103,50,82,130,68,92
	dc.b 98,229,218,71,133,39,60,3,45,90,135,72,42,193,105,163,237,115,126,60,203,139,3,253,107,70,188,146,190,228,218,233,149,244,45,141,127,81,6,186,71,243,231,13,21,124,51,123,45,151
	dc.b 91,133,233,8,237,202,110,77,246,112,81,128,76,225,137,66,130,126,138,9,18,191,215,231,90,236,194,82,232,86,80,46,223,32,139,65,236,103,135,179,80,124,131,16,194,246,250,101,38,18
	dc.b 184,157,110,74,181,140,69,97,180,250,231,150,119,170,85,213,122,186,26,107,192,175,221,74,246,45,71,247,247,117,156,178,129,224,40,126,233,20,11,67,102,157,88,253,221,202,26,160,85,235
	dc.b 186,238,79,232,42,241,56,87,24,215,72,147,213,9,28,137,63,33,164,56,27,17,203,101,86,241,167,78,69,129,255,110,141,142,119,100,241,98,147,160,121,229,25,229,93,71,197,79,3,56
	dc.b 110,9,50,57,11,129,225,245,199,7,127,46,130,12,56,209,149,106,126,81,36,198,138,63,212,167,233,230,171,10,18,230,166,226,62,247,153,10,246,225,3,83,76,184,84,244,77,231,223,62
	dc.b 237,222,225,127,254,187,188,236,189,203,39,82,97,33,37,218,10,196,18,126,56,141,253,36,116,84,226,131,69,29,22,183,81,87,148,14,9,180,200,136,242,195,162,101,179,36,184,253,35,214
	dc.b 58,96,183,78,155,207,208,215,132,100,14,210,93,47,185,39,83,149,203,166,52,29,93,233,220,107,34,124,204,149,61,114,16,199,184,30,178,154,127,10,106,121,88,31,129,135,59,248,198,107
	dc.b 65,178,245,24,109,28,238,248,127,127,110,80,251,121,53,14,235,18,18,175,68,222,220,228,75,187,198,96,198,92,61,190,153,138,45,101,29,111,157,227,103,35,164,115,218,140,196,98,108,65
	dc.b 136,204,27,219,72,40,15,66,133,104,110,216,24,154,124,215,52,97,177,153,57,235,37,17,194,20,104,139,87,141,195,106,69,28,18,13,111,75,106,187,52,85,192,99,93,222,240,132,34,121
	dc.b 31,61,150,243,113,198,48,161,109,178,248,200,45,23,157,191,161,190,11,66,128,6,104,148,35,8,198,208,34,137,244,168,234,156,241,109,79,80,157,122,178,136,205,44,33,39,21,191,116,201
	dc.b 4,78,157,64,87,221,224,156,192,205,168,28,48,184,63,101,75,134,136,245,238,161,102,208,87,119,158,236,57,155,129,135,144,193,118,149,32,204,1,72,236,3,160,147,249,34,33,18,220,154
	dc.b 89,161,11,62,66,95,87,243,225,158,23,1,29,225,39,102,87,188,255,147,199,250,198,144,34,39,196,163,212,250,146,60,65,239,200,225,86,194,137,139,28,232,156,218,234,67,241,154,242,15
	dc.b 234,212,79,156,77,75,196,65,75,227,229,223,152,3,214,245,161,88,113,167,214,250,156,234,243,71,152,32,231,173,45,125,197,131,95,219,158,247,172,69,72,45,231,117,100,111,245,61,10,106
	dc.b 156,219,114,14,72,150,173,211,77,55,199,218,123,179,59,84,69,221,237,21,57,23,126,208,183,13,165,151,207,142,235,228,110,242,86,118,224,68,11,203,140,91,142,42,78,206,150,92,113,52
	dc.b 70,106,98,52,167,110,198,136,160,29
	

; ****** Copper macros  *********

cmove:	macro
	  dc.w		\2&$01fe
	  dc.w		\1
	endm

cmovel:	macro
	  dc.w		\2&$01fe		; Hi-Word
	  dc.w		\1>>16
	  dc.w		(\2&$01fe)+2	; Lo-Word
	  dc.w		\1&$ffff		
	endm

cwait:	macro
	  DC.W ((\2)&$FF)<<8|((\1)&$7F)<<1|1,$FFFE
	endm

cend:	macro
	  dc.w		$ffff,$fffe
	endm

coplist	cmove	0,$1fc
	cmove	$5200,bplcon0
	cmove	0,bplcon1
	cmove	0,bplcon2
	cmove	$c00,bplcon3
	cmove	$11,bplcon4

	cmove	$1c61,diwstrt
	cmove	$3cd1,diwstop
	cmove	$28,ddfstrt
	cmove	$d8,ddfstop

	cmove	$fff,color16
	cmove	$fff,color17
	cmove	$fff,color18
	cmove	$fff,color19
	cmove	$fff,color20
	cmove	$fff,color21
	cmove	$fff,color22
	cmove	$fff,color23
	cmove	$fff,color24
	cmove	$fff,color25
	cmove	$fff,color26
	cmove	$fff,color27
	cmove	$fff,color28
	cmove	$fff,color29
	cmove	$fff,color30
	cmove	$fff,color31


staticcop	cmove	$f00,color00
	cmove	$f00,color01
	cmove	$f00,color02
	cmove	$f00,color03
	cmove	$f00,color04
	cmove	$f00,color05
	cmove	$f00,color06
	cmove	$f00,color07
	
fadecols	cmove	$ff,color08
	cmove	$ff,color09
	cmove	$ff,color10
	cmove	$ff,color11
	cmove	$ff,color12
	cmove	$ff,color13
	cmove	$ff,color14
	cmove	$ff,color15

	cmove	0,bpl1mod
	cmove	0,bpl2mod

pl4	cmovel	0,bpl4pt
pl5	cmovel	0,bpl5pt
	
ypos	set	$1c

copscr
	
	rept	144


	cwait	$6f,ypos
	cmovel	0,bpl1pt
	cmovel	0,bpl2pt
	cmovel	0,bpl3pt
	cmove	0,$1fe
	
ypos	set	ypos+2
	endr
	
	cend
	